#ifndef _DR26
#define _DR26

#include "Adafruit_ADS1X15.h"
#include "ForteSensor.hpp"
#include "Message.hpp"
#include "Pinout.hpp"
#include "esp_log.h"
#include <Wire.h>
#include "NoDataAvailableException.hpp"

class ForteDR26 : public ForteSensor<float> {
  public:
	void setup() override;
	float readData() override;
	void changeGain(adsGain_t gain);
	void setChannel(int channel);
	std::list<Message> buildMessages() override;
	std::list<Message> buildMessages(std::string mesurment_type);
	[[nodiscard]] SensorInformation getSensorInformation() const override;
	static Adafruit_ADS1115 ads1;

  private:
	Adafruit_ADS1115 ads;
	const SensorInformation sensorInformation{"DR26", Protocol::Analog};
	int channel;
};

#endif