//
// Created by cynthya on 10/6/22.
//

#ifndef CLIENT_MEASUREMENTDATA_HPP
#define CLIENT_MEASUREMENTDATA_HPP

#include "ArduinoJson.h"
#include "Protocol.hpp"
#include "SensorInformation.hpp"
#include <list>
#include <optional>
#include <string>
#include <utility>
class MeasurementData {
  public:
	MeasurementData(double value, std::optional<int> channel, std::optional<int> i2cAddress,
	                std::string measurementType)
	    : value(value), measurementType(std::move(measurementType)), channel(channel), i2cAddress(i2cAddress)
	{
	}

	MeasurementData(double value, std::string measurementType)
	    : value(value), measurementType(std::move(measurementType))
	{
	}

	[[nodiscard]] double getValue() const { return value; }
	[[nodiscard]] const std::string &getMeasurementType() const { return measurementType; }
	[[nodiscard]] const std::optional<int> &getChannel() const { return channel; }
	[[nodiscard]] const std::optional<int> &getI2CAddress() const { return i2cAddress; }

  private:
	double value;
	std::string measurementType; // TODO: consider using an enum
	std::optional<int> channel;
	std::optional<int> i2cAddress;
};
#endif // CLIENT_MEASUREMENTDATA_HPP
