#include "MockSensor.hpp"

static const char *TAG = "MOCK";

void MockSensor::setup() {

    ESP_LOGD(TAG, "MOCK Sensor initialized");
    delay(100);
    channel = 0;
}

float MockSensor::readData() {
    // generate a random float value between 0 and 100
    float randomValue = (float)rand() / (float)RAND_MAX * 100.0;
    ESP_LOGD(TAG, "MOCK Sensor read value: %f", randomValue);
    return randomValue;
}


void MockSensor::setChannel(int c) {
    channel = c;
}

std::list<Message> MockSensor::buildMessages() {
    std::list<Message> messages;
    float data = readData();
    MeasurementData MockData{data, channel, {}, "MOCK"};
    messages.emplace_back(MockData, sensorInformation, Time::getInstance().getEpochSeconds());
    return messages;
}

SensorInformation MockSensor::getSensorInformation() const {
    return sensorInformation;
}
