#ifndef _MOCK_SENSOR
#define _MOCK_SENSOR

#include "ForteSensor.hpp"
#include "Message.hpp"
#include "NoDataAvailableException.hpp"
#include "Pinout.hpp"
#include "esp_log.h"
#include <Wire.h>

class MockSensor : public ForteSensor<float> {
  public:
	void setup() override;
	float readData() override;
	void setChannel(int channel);
	std::list<Message> buildMessages() override;
	[[nodiscard]] SensorInformation getSensorInformation() const override;

  private:
	const SensorInformation sensorInformation{"MOCK", Protocol::Mock};
	int channel;
};

#endif